//------------------------------------------------------------------------
//    ADuC7026
//-------------------------------------------------------------------------
#include "hardware.h" //     
#include "adc.h" //     

const U16  Vref_01mV = 25000; //     0,1 
#define MASK_ADC_REZ  0xFFF0000 //     
             //  ADCDAT: 0b0000.1111.1111.1111.0000.0000.0000.0000

  U16 ADCres=0;     //   
  U16 ADCres_sum=0;  //   ( )  
  U16 ADCiter=0;       // 
  U16 ADCres_01mV=0;  //   0,1 
  U16 ADCreg=0;       //    

  U8 r10000=0;  //-----------------------------------
  U8 r1000=0;   //
  U8 r100=0;    //   
  U8 r10=0;     //
  U8 r1=0;      //-----------------------------------

//     
void ADCinit()
  {
    ADCCON = 0x1234; // ,   ,
                   // ,  ADCBUSY ,
                   // - fADC/16, 8   
    ADCCP = 0x0;  //   - ADC0
    REFCON = 0x01; //  
                  //    Vref
  }

//      
void  ADC_of_prog()
  {
    ADCCP = 0x11;  //   - AGND ()
    //ADCOF=0; //    
    delay(100);   //
    ADCCON=0x12B4; // 
    while(ADCSTA == 0);    //  
    while (ADCDAT > 1) //  
       {
    ADCOF++; //    
    delay(100);   //
    ADCCON=0x12B4; // 
    while(ADCSTA == 0);    //  
       }
    //  -    :
    ADCCP = 0x0;  //   - ADC0
    //       
    ADCreg = ADCOF;
    ind_ADCreg(ADCreg);
  }

//     
void  ADC_gn_prog()
  {
    ADCCP = 0x12;  //   -  ()
    //ADCGN=0; //    
    delay(100);   //
    ADCCON=0x12B4; // 
    while(ADCSTA == 0);    //  
    while (ADCDAT < 4094) //  
       {
    ADCGN++; //    
    delay(100);   //
    ADCCON=0x12B4; // 
    while(ADCSTA == 0);    //  
       }
    //  -    :
    ADCCP = 0x0;  //   - ADC0
    //       
    ADCreg = ADCGN;
    ind_ADCreg(ADCreg);
  }

//     
//          
void  ADCstart_ind_rez(U16 n)
  {
   ADCiter=0;
   ADCres_sum=0;
   while (ADCiter < n) //   ?
      {
      ADCCON=0x12B4; // 
      while(ADCSTA == 0);    //  
      ADCres = (ADCDAT & MASK_ADC_REZ)>>16; //   
      ADCres_sum = ADCres_sum + ADCres; // 
      ADCiter++;
      }
   ADCres = ADCres_sum / n;  //     
   ADCres_01mV = (ADCres * Vref_01mV) / 4096; //    0,1 
   //     
   //   
   r1000 = ADCres / 1000;
   ADCres = ADCres % 1000;
   r100 = ADCres / 100;
   ADCres = ADCres % 100;
   r10 = ADCres / 10;
   r1 = ADCres % 10;
   lcd_pro_data(r1000,0);
   lcd_tek_data(r100);
   lcd_tek_data(r10);
   lcd_tek_data(r1);
   //     
   //      
   r10000 = ADCres_01mV / 10000;
   ADCres_01mV = ADCres_01mV % 10000;
   r1000 = ADCres_01mV / 1000;
   ADCres_01mV = ADCres_01mV % 1000;
   r100 = ADCres_01mV / 100;
   ADCres_01mV = ADCres_01mV % 100;
   r10 = ADCres_01mV / 10;
   r1 = ADCres_01mV % 10;
   lcd_pro_data(r10000,64);
   lcd_tek_data(r1000);
   lcd_tek_data(r100);
   lcd_tek_data(r10);
   lcd_tek_data(',');
   lcd_tek_data(r1);
   lcd_pro_data('m',71);
   lcd_tek_data('B');
  }

//        
void ind_ADCreg(U16 ADCreg)
{
   //     
   //   
   r1000 = ADCreg / 1000;
   ADCreg = ADCreg % 1000;
   r100 = ADCreg / 100;
   ADCreg = ADCreg % 100;
   r10 = ADCreg / 10;
   r1 = ADCreg % 10;
   lcd_pro_data(r1000,9);
   lcd_tek_data(r100);
   lcd_tek_data(r10);
   lcd_tek_data(r1);
}
//-------------------------------------------------------------------










