//---------------------------------------------------------------------------------
//     ADuC7026
//---------------------------------------------------------------------------------
#include "hardware.h" //     

//   ----------------------------------------------------
void CPUinit(void)
{
// PLL ()
  PLLKEY1=0xAA;
  PLLCON=0x01;  //  32 + 
  PLLKEY2=0x55;

//   
  POWKEY1=0x01;
  POWCON=0x06;   //   705 
  POWKEY2=0xF4;

// GPIO
  GP0CON=0x0; //
  GP2CON=0x0; //   - GPIO
  GP4CON=0x0; //

//   GPIO      
  GP0DAT=0x6000000;
  //0b0000 0110 0000 0000 0000 0000 0000 0000  P0.1,P0.2 - 

  GP2DAT=0xFF000000;
  //0b1111 1111 0000 0000 0000 0000 0000 0000  P2.0-P2.7 - 

  GP4DAT=0x80000000;
  //0b1000 0000 0000 0000 0000 0000 0000 0000  P4.7 -  P4.0-P4.3 - 
}

//--------------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------------
void INTERRUPTSinit(void)
{
  FIQEN=0x0; //   FIQ
  IRQEN=0x0; //   IRQ
  IRQEN=RTOS_TIMER_BIT; //   0  IRQ
}

//  --------------------------------------------------------------
#pragma vector=0x18
__irq __arm void irq_handler(void)
{
  if ((IRQSTA & RTOS_TIMER_BIT) != OFF) //   - Timer0 IRQ?
       {	
       Timer0Interrupt(); //    TIMER0 									
       } 				
  return ;
}

//-   TIMER0 --------------------------------------------
static void Timer0Interrupt()
{
  opros_kn0();   //  0
  opros_kn1();   //  1
  opros_kn2();   //  2
  opros_kn3();   //  3

  static U8 old_state;

  //   
  // -U   
  if (old_state==OFF)
      {
      OUT_U_LCD_UP; //  -U 
      old_state=ON;
      }
  else
      {
      OUT_U_LCD_DOWN; //  -U 
      old_state=OFF;
      }

  T0CLRI=0x01; //    0
}

//   TIMER0 -----------------------------------------
void TIMER0initstart()
{
  T0LD=3; //        
  T0CON=0xC8; //    /256,  , 0 
              //704500/256/3 = 917  -    0
}

//  1 --------------------------------------------------
void pulse_LED1()
{
  A_LED1_ON;     //   1
  delay(5000);   // ()
  A_LED1_OFF;    //   1
}
//------------------------------------------------------------------------
