//----------------------------------------------------------------------------
//       ADuC7026
//-----------------------------------------------------------------------------
#include <inarm.h>      //     
#include <ioaduc7026.h>  //     

//  
typedef unsigned int            U8;             /*  8 bit unsigned UPGRADE*/
typedef signed int              S8;             /*  8 bit signed   UPGRADE*/
typedef unsigned int            U16;            /* 16 bit unsigned */
typedef signed int              S16;            /* 16 bit signed */
typedef unsigned long int       U32;            /* 32 bit unsigned */
typedef signed long int         S32;            /* 32 bit signed */

//   ,    
void CPUinit(void);
void INTERRUPTSinit(void);
__irq __arm void irq_handler(void);
void TIMER0initstart();
static void Timer0Interrupt();

//    1
void pulse_LED1();

//   
void opros_kn0(); //   0
void opros_kn1(); //   1
void opros_kn2(); //   2
void opros_kn3(); //   3

//      
void  delay(U32);

//    / 
void lcd_pulse_E();

//     
void lcd_send_byte(U8);

//        
//   
void lcd_pro_data(U8, U8);

//        
//   
void lcd_tek_data(U8);

//     
void lcd_com(U8);

//   
void lcd_init();

//    
void lcd_clear();

//----------------------------------------------------------------------------------------
//  
#define OFF       0
#define ON        1

//---------------------------------------------------------------------------------------
// ,    
#define  BIT_SET(address,bit)     (address |= (1 << bit))
#define  BIT_CLEAR(address,bit)   (address &= ~(1 << bit))
#define  BIT_TEST(address,bit)    (address & (1 << bit))

//----------------------------------------------------------------------------------------
//        -U 
#define   OUT_U_LCD_DOWN     BIT_SET(GP4CLR,23)
#define   OUT_U_LCD_UP       BIT_SET(GP4SET,23)

//      
#define   A_LED1_OFF      BIT_CLEAR(GP0DAT,17)
#define   A_LED1_ON       BIT_SET(GP0DAT,17)
#define   A_LED2_OFF      BIT_CLEAR(GP0DAT,18)
#define   A_LED2_ON       BIT_SET(GP0DAT,18)

//-   
#define  DREB_KN0_K   100
#define  DREB_KN1_K   100
#define  DREB_KN2_K   100
#define  DREB_KN3_K   100

//    
#define   IN_KNOP0        BIT_TEST(GP4DAT,0) //  0
#define   IN_KNOP1        BIT_TEST(GP4DAT,1) //  1
#define   IN_KNOP2        BIT_TEST(GP4DAT,2) //  2
#define   IN_KNOP3        BIT_TEST(GP4DAT,3) //  3

// /  
#define   LCD_RW_CLR    BIT_CLEAR(GP2DAT,17)
#define   LCD_RW_SET    BIT_SET(GP2DAT,17)
#define   LCD_RS_CLR    BIT_CLEAR(GP2DAT,18)
#define   LCD_RS_SET    BIT_SET(GP2DAT,18)
#define   LCD_E_CLR     BIT_CLEAR(GP2DAT,19)
#define   LCD_E_SET     BIT_SET(GP2DAT,19)
#define   LCD_D4_CLR    BIT_CLEAR(GP2DAT,20)
#define   LCD_D4_SET    BIT_SET(GP2DAT,20)
#define   LCD_D5_CLR    BIT_CLEAR(GP2DAT,21)
#define   LCD_D5_SET    BIT_SET(GP2DAT,21)
#define   LCD_D6_CLR    BIT_CLEAR(GP2DAT,22)
#define   LCD_D6_SET    BIT_SET(GP2DAT,22)
#define   LCD_D7_CLR    BIT_CLEAR(GP2DAT,23)
#define   LCD_D7_SET    BIT_SET(GP2DAT,23)








