//------------------------------------------------------------------------
//   HD44780.      4- .
//------------------------------------------------------------------------
#include "hardware.h" //     

void delay(U32 ticks)   //    
  {
     for(; ticks; --ticks)
	    {
		asm ("nop");
	    }
  }

void lcd_pulse_E()  //  / 
  {
  delay(10);
  LCD_E_SET;  //   E
  delay(10);
  LCD_E_CLR;  //   E
  delay(10);
  }

void lcd_send_byte(U8 byte) //   
  {
    if (BIT_TEST(byte,4))  LCD_D4_SET; //---------------------
    else   LCD_D4_CLR;                 //
    if (BIT_TEST(byte,5))  LCD_D5_SET; //
    else   LCD_D5_CLR;                 //
    if (BIT_TEST(byte,6))  LCD_D6_SET; //   
    else   LCD_D6_CLR;                 //
    if (BIT_TEST(byte,7))  LCD_D7_SET; //
    else   LCD_D7_CLR;                 //
  lcd_pulse_E();                       //---------------------
    if (BIT_TEST(byte,0))  LCD_D4_SET; //---------------------
    else   LCD_D4_CLR;                 //
    if (BIT_TEST(byte,1))  LCD_D5_SET; //
    else   LCD_D5_CLR;                 //   
    if (BIT_TEST(byte,2))  LCD_D6_SET; //
    else   LCD_D6_CLR;                 //
    if (BIT_TEST(byte,3))  LCD_D7_SET; //
    else   LCD_D7_CLR;                 //
  lcd_pulse_E();                       //---------------------
  }

//           
void lcd_pro_data(U8 date, U8 addr)
  {
   LCD_RW_CLR;          //   
   LCD_RS_CLR;          //  
   BIT_SET(addr,7);     //    
   lcd_send_byte(addr); // 
   delay(200);         //   
   LCD_RS_SET;          //  
   if (date < 10)  lcd_send_byte(date + 0x30); //  
   else   lcd_send_byte(date);                //  ( )
   delay(200);         //   
  }

//           
void lcd_tek_data(U8 date)
  {
   LCD_RW_CLR;          //   
   LCD_RS_SET;          //  
   if (date < 10) lcd_send_byte(date + 0x30); //  
   else    lcd_send_byte(date);             //  ( )
   delay(200);         //   
  }

void lcd_com(U8 comand) //    
  {
   LCD_RW_CLR;  //   
   LCD_RS_CLR;  //  
   lcd_send_byte(comand); // 
   delay(5000); //   
  }

void lcd_init() //  
  {
   lcd_com(0x28);   //4-  , 2 ,  57
   lcd_com(0x01);   // ,    
   lcd_com(0x06);   //  ,  
   lcd_com(0x0C);   // ,  
  }

void lcd_clear()  //  
  {
   lcd_com(0x01);   // ,    
  }
//-----------------------------------------------------------------------
